'use strict';

exports.__esModule = true;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _FormItemModel = require('./FormItemModel');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FormsModel = function () {
  function FormsModel() {
    var _this = this;

    (0, _classCallCheck3.default)(this, FormsModel);

    this.get = function () {
      return _this.__get__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.add = function () {
      return _this.__add__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.remove = function () {
      return _this.__remove__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.validate = function () {
      return _this.__validate__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.reload = function () {
      return _this.__reload__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.addErrors = function () {
      return _this.__addErrors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.init = function () {
      return _this.__init__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.reset = function () {
      return _this.__reset__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.makeDirty = function () {
      return _this.__makeDirty__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.makeSubmitted = function () {
      return _this.__makeSubmitted__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isValid = function () {
      return _this.__isValid__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.isTouched = function () {
      return _this.__isTouched__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.data = function () {
      return _this.__data__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.values = function () {
      return _this.__values__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.errors = function () {
      return _this.__errors__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.list = function () {
      return _this.__list__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.getPublic = function () {
      return _this.__getPublic__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.forms = {};
  }

  FormsModel.prototype.__get__REACT_HOT_LOADER__ = function __get__REACT_HOT_LOADER__(name, defaultValue) {
    return this.forms[name] || defaultValue;
  };

  FormsModel.prototype.__add__REACT_HOT_LOADER__ = function __add__REACT_HOT_LOADER__(_ref, asList) {
    var name = _ref.name,
        validator = _ref.validator,
        excluded = _ref.excluded;

    var model = new _FormItemModel.FormItemModel(name, validator, excluded);
    if (asList) {
      if (!this.forms[name]) {
        this.forms[name] = [];
      }
      this.forms[name].push(model);
    } else {
      this.forms[name] = model;
    }
    return model;
  };

  FormsModel.prototype.__remove__REACT_HOT_LOADER__ = function __remove__REACT_HOT_LOADER__(model) {
    var name = model.name;
    if (Array.isArray(this.forms[name])) {
      var index = this.forms[name].findIndex(function (form) {
        return form.id === model.id;
      });
      if (index > -1) {
        this.forms[name].splice(index, 1);
      }
      if (!this.forms[name].length) {
        delete this.forms[name];
      }
    } else {
      delete this.forms[name];
    }
  };

  FormsModel.prototype.__validate__REACT_HOT_LOADER__ = function __validate__REACT_HOT_LOADER__() {
    this.list().forEach(function (form) {
      return form.validate();
    });
  };

  FormsModel.prototype.__reload__REACT_HOT_LOADER__ = function __reload__REACT_HOT_LOADER__() {
    this.list().forEach(function (form) {
      return form.reload();
    });
  };

  FormsModel.prototype.__addErrors__REACT_HOT_LOADER__ = function __addErrors__REACT_HOT_LOADER__(errors) {
    var _this2 = this;

    (0, _keys2.default)(this.forms).forEach(function (key) {
      if (Array.isArray(_this2.forms[key])) {
        var formsErrors = errors[key] || [];
        return _this2.forms[key].forEach(function (form, index) {
          return form.addErrors(formsErrors[index]);
        });
      }
      return _this2.forms[key].addErrors(errors[key]);
    });
  };

  FormsModel.prototype.__init__REACT_HOT_LOADER__ = function __init__REACT_HOT_LOADER__(data) {
    var _this3 = this;

    (0, _keys2.default)(this.forms).forEach(function (key) {
      if (Array.isArray(_this3.forms[key])) {
        var formsValues = data[key] || [];
        return _this3.forms[key].forEach(function (form, index) {
          return form.init(formsValues[index]);
        });
      }
      return _this3.forms[key].init(data[key]);
    });
  };

  FormsModel.prototype.__reset__REACT_HOT_LOADER__ = function __reset__REACT_HOT_LOADER__() {
    this.list().forEach(function (form) {
      return form.reset();
    });
  };

  FormsModel.prototype.__makeDirty__REACT_HOT_LOADER__ = function __makeDirty__REACT_HOT_LOADER__() {
    this.list().forEach(function (form) {
      return form.makeDirty();
    });
  };

  FormsModel.prototype.__makeSubmitted__REACT_HOT_LOADER__ = function __makeSubmitted__REACT_HOT_LOADER__() {
    this.list().forEach(function (form) {
      return form.makeSubmitted();
    });
  };

  FormsModel.prototype.__isValid__REACT_HOT_LOADER__ = function __isValid__REACT_HOT_LOADER__() {
    return this.list().every(function (form) {
      return form.isValid();
    });
  };

  FormsModel.prototype.__isTouched__REACT_HOT_LOADER__ = function __isTouched__REACT_HOT_LOADER__() {
    return this.list().some(function (form) {
      return form.isTouched();
    });
  };

  FormsModel.prototype.__data__REACT_HOT_LOADER__ = function __data__REACT_HOT_LOADER__() {
    var _this4 = this;

    var values = {};
    (0, _keys2.default)(this.forms).reduce(function (prev, key) {
      if (Array.isArray(_this4.forms[key])) {
        prev[key] = _this4.forms[key].map(function (form) {
          return form.data();
        });
        if (!prev[key].length) {
          delete prev[key];
        }
      } else {
        prev[key] = _this4.forms[key].data();
      }
      return prev;
    }, values);
    return values;
  };

  FormsModel.prototype.__values__REACT_HOT_LOADER__ = function __values__REACT_HOT_LOADER__() {
    var _this5 = this;

    var values = {};
    (0, _keys2.default)(this.forms).reduce(function (prev, key) {
      if (Array.isArray(_this5.forms[key])) {
        prev[key] = _this5.forms[key].filter(function (form) {
          return !form.excluded;
        }).map(function (form) {
          return form.values();
        });
        if (!prev[key].length) {
          delete prev[key];
        }
      } else if (!_this5.forms[key].excluded) {
        prev[key] = _this5.forms[key].values();
      }
      return prev;
    }, values);
    return values;
  };

  FormsModel.prototype.__errors__REACT_HOT_LOADER__ = function __errors__REACT_HOT_LOADER__() {
    var _this6 = this;

    var errors = {};
    (0, _keys2.default)(this.forms).forEach(function (key) {
      if (Array.isArray(_this6.forms[key])) {
        errors[key] = [];
        return _this6.forms[key].forEach(function (form) {
          errors[key].push(form.getErrors());
        });
      }
      errors[key] = _this6.forms[key].getErrors();
    });
    return errors;
  };

  FormsModel.prototype.__list__REACT_HOT_LOADER__ = function __list__REACT_HOT_LOADER__() {
    return (0, _values2.default)(this.forms).reduce(function (list, current) {
      if (Array.isArray(current)) {
        list = [].concat(list, current);
      } else {
        list.push(current);
      }
      return list;
    }, []);
  };

  FormsModel.prototype.__getPublic__REACT_HOT_LOADER__ = function __getPublic__REACT_HOT_LOADER__() {
    var _this7 = this;

    var forms = {};
    (0, _keys2.default)(this.forms).forEach(function (key) {
      if (Array.isArray(_this7.forms[key])) {
        forms[key] = [];
        return _this7.forms[key].forEach(function (form) {
          forms[key].push(form.getPublic());
        });
      }
      forms[key] = _this7.forms[key].getPublic();
    });
    return forms;
  };

  return FormsModel;
}();

var _default = FormsModel;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(FormsModel, 'FormsModel', '/Users/flamps/Documents/React/github/Flamps/vb-react-form/src/FormsV1/Form/FormsModel.js');

  __REACT_HOT_LOADER__.register(_default, 'default', '/Users/flamps/Documents/React/github/Flamps/vb-react-form/src/FormsV1/Form/FormsModel.js');
}();

;